/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#define PI 3.1415

static char str[128];

int process_input(int len)
{
    int long_out_block;
    int long_in_block = len;
    int i,x;

    if (decimation > long_in_block || decimation<0) {
        Log("Error invalid decimation value: %d len %d\n", decimation, long_in_block);
        return 0;
    }

    long_out_block = ((long_in_block - 1) / decimation) + 1;

    if (long_out_block > OUTPUT_MAX_DATA) {
        Log("Output sequence bigger than buffer\n");
        return 0;
    }


    Log("Using decimator %d input %d output %d\n", decimation, long_in_block, long_out_block);
    
    /* process data */
    for (i = 0; i < long_out_block; i++) {
        if (i * decimation < long_in_block)
            x = (int) input_data[i * decimation];
        else
            x = 0;
        output_data[i] = (output1_t) x;

    }

    /* send throught output */
    SendItf(0,long_out_block);

    /* set stats variable */
    SetStatsValue(stat_signal, output_data, long_out_block);

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}


void ConfigInterfaces(){}


