/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int input_i[INPUT_MAX_DATA*8],output_i[INPUT_MAX_DATA*8];

int fil[8]={1,1,1,1,1,1,1,1};
int mem[8];

/******************************
 *    CONVOLUTION FUNCTION    *
 ******************************/
int conv(int *filtre, int *estat, int length, int din)
{
	int i;
	int res=0;

	for (i=length-1; i>0; i--)
		estat[i]=estat[i-1];
	estat[0]=din;

	for (i=0; i<length; i++)
		res+=filtre[i]*estat[i];

	return(res);
}

int process_input(int len)
{
    int i;
    int nsamples;

    nsamples=typeSizeArray(datatype,len);

    type2int(input_data,input_i,len,datatype);
    
    for (i=0;i<nsamples;i++) {
        output_i[i]=conv(fil,mem,8,input_i[i]);
    }

    int2type(output_i,output_data,len,datatype);
    
    /* send throught output */
    SendItf(0,typeSizeArray(datatype,len));

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    memset(mem,0,sizeof(int)*8);
    return 1;
}


void ConfigInterfaces()
{
    
}



