/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "typetools.h"

#define PI 3.1415

int data_i[INPUT_MAX_DATA],data_q[INPUT_MAX_DATA];

int rcv_i,rcv_q;

int process_input_i(int len)
{
    rcv_i=len;
    return 1;
}

int process_input_q(int len)
{
    rcv_q=len;
    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{

    int len;
    int i,j;
    int s;

    if (!rcv_i) {
        Log("Error. Inphase data not available.\n");
        return 1;
    }
    if (!rcv_q) {
        Log("Error. Quadrature data not available.\n");
        return 1;
    }

    if (rcv_i!=rcv_q) {
        Log("Error. Inphase and Quadrature lengths not equal\n");
        return 1;
    }

    len=typeNsamplesArray(datatype,rcv_i);

    type2int(input_data_i,data_i,len,datatype);
    type2int(input_data_q,data_q,len,datatype);

    for (i=0;i<len;i++) {
        output[i] = (int) data_i[i]*cosf((float) 2.0*PI*fsin*i/freq) -
                (int) data_q[i]*sin((float) 2.0*PI*fsin*i/freq);
    }

    int2type(output,output_data,len,datatype);

    SendItf(0,rcv_i);

    rcv_i=0;
    rcv_q=0;

    return 1;
}

int InitCustom()
{
    rcv_i=0;
    rcv_q=0;
    return 1;
}

void ConfigInterfaces(){}



