/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "modem.h"
#include "typetools.h"

char outputbits[INPUT_MAX_DATA*8];

int data_i[INPUT_MAX_DATA],data_q[INPUT_MAX_DATA];

int bitspersymbol;

int rcv_i,rcv_q;

int process_input_i(int len)
{
    rcv_i=1;
}

int process_input_q(int len)
{
    rcv_q=1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{

    int len;
    int i,j;
    int s;

    if (!rcv_i && rcv_q) {
        Log("Error. Inphase data not available.\n");
        return 1;
    }
    if (!rcv_q && rcv_i) {
        Log("Error. Quadrature data not available.\n");
        return 1;
    }

    if (rcv_i!=rcv_q) {
        Log("Error. Inphase and Quadrature lengths not equal\n");
        return 1;
    }

    len=typeNsamplesArray(datatype,rcv_i);

    bitspersymbol = getbitspersymbol(modulation);

    type2int(input_data_i,data_i,datatype,len);
    type2int(input_data_q,data_q,datatype,len);

    j=0;
    for (i=0;i<len;i++) {
        Demodulate(modulation,data_i[j],data_q[j],&s);
        ConvertSymbolToBits(s,&outputbits[j],bitspersymbol);
        j+=bitspersymbol;
    }

    char2bin(outputbits,output_data,j);

    SendItf(0,typeSizeArray(TYPE_BITSTREAM,j));

    rcv_i=0;
    rcv_q=0;

    return 1;
}

int InitCustom()
{
    rcv_i=0;
    rcv_q=0;
    return 1;
}

void ConfigInterfaces(){}



